Player = {}
Player.__index = Player 

function Player.new(x, y)
    local instance = setmetatable({}, Player)
    instance.x = 22
    instance.y = 12
    instance.speed = 10
    instance.rotation_speed = 0.1
    instance.a = math.rad(90)
    instance.delX = math.cos(instance.a)
    instance.delY = math.sin(instance.a)
    instance.planeX = 0 
    instance.planeY = 0.66

    return instance
end

function Player:move(dt)
    --moving forward and backwards 
    if love.keyboard.isScancodeDown("w") then 
        nextX = math.floor((self.x + self.delX * dt * self.speed) / tile_size) +1
        nextY = math.floor((self.y + self.delY * dt * self.speed) / tile_size) +1
        self.x = self.x + self.delX * dt * self.speed
        self.y = self.y + self.delY * dt * self.speed
    end 
    if love.keyboard.isScancodeDown("s") then 
        nextX = math.floor((self.x - self.delX * dt * self.speed) / tile_size ) +1
        nextY = math.floor((self.y - self.delY * dt * self.speed) / tile_size)  +1
        self.x = self.x - self.delX * dt * self.speed
        self.y = self.y - self.delY * dt * self.speed
    end 
    --rotation
    
end

function Player:rotate(dt)

        if love.keyboard.isScancodeDown("d") then 
            --both camera direction and camera plane must be rotated
            local oldDirX = self.delX
            self.delX = self.delX * math.cos(-self.rotation_speed) - self.delY * math.sin(-self.rotation_speed)
            self.delY = oldDirX * math.sin(-self.rotation_speed) + self.delY * math.cos(-self.rotation_speed)
            local oldPlaneX = self.planeX
            self.planeX = self.planeX * math.cos(-self.rotation_speed) - self.planeY * math.sin(-self.rotation_speed)
            self.planeY = oldPlaneX * math.sin(-self.rotation_speed) + self.planeY * math.cos(-self.rotation_speed)
        end
        if love.keyboard.isScancodeDown("a") then 
            --both camera direction and camera plane must be rotated
            local oldDirX = self.delX
            self.delX = self.delX * math.cos(self.rotation_speed) - self.delY * math.sin(self.rotation_speed)
            self.delY = oldDirX * math.sin(self.rotation_speed) + self.delY * math.cos(self.rotation_speed)
            local oldPlaneX = self.planeX
            self.planeX = self.planeX * math.cos(self.rotation_speed) - self.planeY * math.sin(self.rotation_speed)
            self.planeY = oldPlaneX * math.sin(self.rotation_speed) + self.planeY * math.cos(self.rotation_speed)
        end

end

function Player:draw()
    love.graphics.setColor(1, 0, 0)
    love.graphics.circle("fill", self.x*16, self.y*16, 5)
    love.graphics.line(self.x*16, self.y*16, self.x*16 + self.delX*100, self.y*16 + self.delY * 100)
    love.graphics.setColor(1, 1, 1)
end